<?
/*********************
> DESCRIO

Script faz backup de vrios databases do mysql e envia por email
Extrai o SQL - Salva em um arquivo .sql - Zipa - Manda por e-mail - Apaga o .sql e o .zip

> OBSERVAES
dar permisso 777 na pasta onde est o script.

**** Opcional ****
Caso vc tenha receio de invaso por ter neste arquivo a senha do mysql, coloque este script 
fora da pasta public_html. e ento vc pode criar um arquivo na raiz do site e dar include neste arquivo:

include "../backup/backup.php";

***** Dica ******

Crie um cronjob no seu cpanel ou no prprio linux para executar este script todo dia, 
ento vc receber automaticamente seu backup sem precisar ficar executando est pgina td vez que quiser um backup.

Gustavo Lopes - gustavo@hostflex.com.br

******************************/

// Configuraes Mysql


$host_externo = "localhost"; // host
$usuario = "usuario_do_bd"; // usurio do mysql
$senha = "senha_do_bd"; // senha do mysql
$databases = array("nome_do_bd"); // base para backup

// Configuraes E-mail, recebimento do backup

$remetente = "Backup do Sistema tal"; //coloque o nome que quiser
$email_remetente = "email_que_vai_enviar_o_backup";

$assunto = "Backup do Mysql - Database"; 
$mensagem = " - Backup do Mysql;
Data: ".date("d/m/Y")." Hora: ".date("H:i:s")."
IP: ".$_SERVER['REMOTE_ADDR']."
Sistema de Backup dos Banco de Dados"; // Mensagem no e-mail de backup


$destinatario = "Backup tal";
$email_destinatario = "email_que_vai_receber_o_backup";

// Configuraes de arquivos

$quero_zipar = TRUE; // TRUE or FALSE - Caso no quiser ZIP receber em txt.

$receber_backup_mail = TRUE; // TRUE or FALSE - Voc pode optar por apenas salvar o backup na pasta
$excluir_backups = TRUE; // TRUE or FALSE - Depois de enviado o email deletar os backups do servidor.


// Fim das configuraes
 

/////// FINALIZA AS CONFIGURAES E INICIA A ROTINA

set_time_limit(0);

require("pclzip.lib.php");  //biblioteca para ZIP

mysql_connect(($ip = $_SERVER['REMOTE_ADDR'] == " 127.0.0.1"?'localhost':$host_externo), $usuario, $senha) or die ("Erro ao conectar no Mysql");

// FUNES

function sqlAddslashes($str = '', $is_like = FALSE)
{
    if ($is_like)
    {
        $str = str_replace('\\', '\\\\\\\\', $str);
        }else{
        $str = str_replace('\\', '\\\\', $str);
        }
        $str = str_replace('\'', '\\\'', $str);
        return $str;
}

function dumptb($table) {
    $nline = "\n";
    $dp = "CREATE TABLE $table ($nline";
    $firstfield = 1;
    $fields_array = mysql_query("SHOW FIELDS FROM $table");
    
    while ($field = mysql_fetch_array($fields_array))
    {
        if (!$firstfield)
        {
            $dp .= ",\n";
        }else{
            $firstfield = 0;
        }
        $dp .= "\t".$field["Field"]." ". $field["Type"];
        if (isset($field['Default']) && $field['Default'] != '')
        {
                    $dp .= ' default \'' . sqlAddslashes($field['Default']) . '\'';
        }
        if ($field['Null'] != 'YES')
        {
            $dp .= ' NOT NULL ';
        }
        if (!empty($field["Extra"]))
        {
            $dp .= $field["Extra"];
        }
    }
    mysql_free_result($fields_array);

    $keysindex_array = mysql_query("SHOW KEYS FROM $table");

    while ($key = mysql_fetch_array($keysindex_array))
    {
        $kname = $key['Key_name'];
        if ($kname != "PRIMARY" and $key['Non_unique'] == 0)
        {
            $kname = "UNIQUE|$kname";
        }

        $index[$kname][] = $key['Column_name'];
    }
    mysql_free_result($keysindex_array);
    
    while(list($kname, $columns) = @each($index))
    {
        $dp .= ",\n";
        $colnames = implode($columns,",");
        if($kname == 'PRIMARY')
        {
            $dp .= "\tPRIMARY KEY ($colnames)";
        }else{
            if (substr($kname,0,6) == 'UNIQUE')
            {
                $kname = substr($kname,7);
            }
            $dp .= "   KEY $kname ($colnames)";
        }
    }
    $dp .= "\n);\n\n";
    $rows = mysql_query("SELECT * FROM $table");
    $numfields=mysql_num_fields($rows);
    
    while ($row = mysql_fetch_array($rows))
    {
        $dp .= "INSERT INTO $table VALUES(";
        $fieldcounter=-1;
        $firstfield=1;
        while (++$fieldcounter<$numfields)
        {
            if(!$firstfield)
            {
                $dp .=' , ';
            }else{
                $firstfield=0;
            }
            if (!isset($row[$fieldcounter]))
            {
                $dp .= 'NULL';
            }else{
                $dp .= "'".mysql_escape_string($row[$fieldcounter])."'";
            }
        }
        $dp .= ");\n";
    }
    mysql_free_result($rows);
    return $dp;
}

// SELEO DOS DATABASES
$n=0;
while($databases[$n]){ 
mysql_select_db($databases[$n]);

// Fim da seleo

$file_name = $databases[$n].date('--Y-m-d-H-i-s').".sql";
$filehandle = fopen($file_name,'w');
$result = mysql_query("SHOW tables"); 
    while ($row = mysql_fetch_array($result))
    {
        fwrite($filehandle,dumptb($row[0])."\n\n\n");
    }
fclose($filehandle);


if ($quero_zipar == TRUE){ // ZIPANDO

	$archive = new PclZip("backup-".$databases[$n].".zip");
	$list = $archive->create(array(
						
						array( PCLZIP_ATT_FILE_NAME => $folder_name.$file_name)
					  ),
					  PCLZIP_OPT_ADD_PATH, $databases[$n],
					  PCLZIP_OPT_REMOVE_PATH, $folder_name);
	if ($list == 0) {
	  die("ERROR : '".$archive->errorInfo(true)."'");
	}

$file_name	= "backup-".$databases[$n].".zip";
} //trmino do zip



if ($receber_backup_mail == TRUE){ // ENVIANDO ARQUIVO POR EMAIL 

require_once("class.phpmailer.php");
    
$mail = new PHPMailer();
$mail->From  = $email_remetente;
$mail->FromName = $remetente;
$mail->Host     = "localhost:25";
$mail->Mailer   = "smtp";
$mail->Body		= $mensagem;
$mail->ContentType = "text/html";
$mail->Subject	= "Backup Mysql - ".date("d/m/Y");
$mail->AddAddress($email_destinatario ,$destinatario);
$mail->AddAttachment($file_name);  
   
if(!$mail->Send())
	echo "erro ao enviar bkp por email!";
else
	echo "email enviado!";

} // Trmino do envio 



if($excluir_backups == TRUE && $receber_backup_mail == TRUE){

	$dir = "./";
	$dh = opendir($dir);
	
	while (false !== ($filename = readdir($dh))) {
	
		if ((substr($filename,-4) == ".sql")||(substr($filename,-4)== ".zip")) 
			{ 
				unlink($dir.$filename);
				if (unlink) echo "$filename - excludo<br />"; 
				else echo "$filename - erro ao excluir<br />";
			}
	}
}

echo "<h1>Backup realizado com sucesso";
if ($receber_backup_mail == TRUE){
		echo "- Em breve voc receber no e-mail: $email_destinatario</h1>";
	}else{
			echo "- Voc no acionou a diretiva $receber_backup_mail, portanto dever fazer o download do arquivo de backup na pasta do script";
		}
		
$n++;} // fim
?>